Index: monasca-api-2.2.1.dev9/monasca_api/common/repositories/cassandra/metrics_repository.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/common/repositories/cassandra/metrics_repository.py
+++ monasca-api-2.2.1.dev9/monasca_api/common/repositories/cassandra/metrics_repository.py
@@ -570,55 +896,47 @@ class MetricsRepository(metrics_reposito
             if not alarm_id_list:
                 return json_alarm_history_list
 
-            select_stmt = """
-              select alarm_id, time_stamp, metrics, new_state, old_state,
-              reason, reason_data, sub_alarms, tenant_id
-              from alarm_state_history
-              where tenant_id = %s
-              """
-
-            parms = [tenant_id.encode('utf8')]
-
-            place_holders = ["%s"] * len(alarm_id_list)
-
-            in_clause = ' and alarm_id in ({}) '.format(
-                ",".join(place_holders))
-
-            select_stmt += in_clause
-
-            parms.extend(alarm_id_list)
-
-            if offset and offset != '0':
+            conditions = [ALARM_TENANT_ID_EQ]
+            params = [tenant_id.encode('utf8')]
+            if len(alarm_id_list) == 1:
+                conditions.append(ALARM_ID_EQ)
+                params.append(alarm_id_list[0])
+            else:
+                conditions.append(' and alarm_id in ({}) '.format(','.join(['%s'] * len(alarm_id_list))))
+                for alarm_id in alarm_id_list:
+                    params.append(alarm_id)
 
-                select_stmt += ' and time_stamp > %s '
-                dt = timeutils.normalize_time(timeutils.parse_isotime(offset))
-                parms.append(self._get_millis_from_timestamp(dt))
+            if offset:
+                conditions.append(OFFSET_TIME_GT)
+                params.append(offset)
 
             elif start_timestamp:
-
-                select_stmt += ' and time_stamp >= %s '
-                parms.append(int(start_timestamp * 1000))
+                conditions.append(START_TIME_GE)
+                params.append(int(start_timestamp * 1000))
+            else:
+                conditions.append('')
 
             if end_timestamp:
-                select_stmt += ' and time_stamp <= %s '
-                parms.append(int(end_timestamp * 1000))
+                conditions.append(END_TIME_LE)
+                params.append(int(end_timestamp * 1000))
+            else:
+                conditions.append('')
 
             if limit:
-                select_stmt += ' limit %s '
-                parms.append(limit + 1)
-
-            stmt = SimpleStatement(select_stmt,
-                                   fetch_size=2147483647)
+                conditions.append(LIMIT_CLAUSE)
+                params.append(limit + 1)
+            else:
+                conditions.append('')
 
-            rows = self.cassandra_session.execute(stmt, parms)
+            rows = self.session.execute(ALARM_HISTORY_CQL % tuple(conditions), params)
 
             if not rows:
                 return json_alarm_history_list
 
             sorted_rows = sorted(rows, key=lambda row: row.time_stamp)
 
-            for (alarm_id, time_stamp, metrics, new_state, old_state, reason,
-                 reason_data, sub_alarms, tenant_id) in sorted_rows:
+            for (tenant_id, alarm_id, time_stamp, metrics, new_state, old_state, reason,
+                 reason_data, sub_alarms) in sorted_rows:
 
                 alarm = {u'timestamp': self._isotime_msec(time_stamp),
                          u'alarm_id': alarm_id,
@@ -628,10 +946,10 @@ class MetricsRepository(metrics_reposito
                          u'reason': reason,
                          u'reason_data': reason_data,
                          u'sub_alarms': rest_utils.from_json(sub_alarms),
-                         u'id': str(self._get_millis_from_timestamp(time_stamp)
-                                    ).decode('utf8')}
+                         u'id': str(int((time_stamp - self.epoch).total_seconds() * 1000))}
 
                 if alarm[u'sub_alarms']:
+
                     for sub_alarm in alarm[u'sub_alarms']:
                         sub_expr = sub_alarm['sub_alarm_expression']
                         metric_def = sub_expr['metric_definition']
@@ -648,100 +966,14 @@ class MetricsRepository(metrics_reposito
             raise exceptions.RepositoryException(ex)
 
     @staticmethod
-    def _isotime_msec(timestamp):
-        """Stringify datetime in ISO 8601 format + millisecond.
-        """
-        st = timestamp.isoformat()
-        if '.' in st:
-            st = st[:23] + 'Z'
-        else:
-            st += '.000Z'
-        return st.decode('utf8')
-
-    @staticmethod
-    def _get_millis_from_timestamp(dt):
-        dt = timeutils.normalize_time(dt)
-        return int((dt - datetime(1970, 1, 1)).total_seconds() * 1000)
-
-    def list_dimension_values(self, tenant_id, region, metric_name,
-                              dimension_name):
-
+    def check_status():
         try:
-
-            parms = []
-
-            query = self._build_select_metric_map_query(tenant_id, region, parms)
-
-            name_clause = self._build_name_clause(metric_name, parms)
-
-            dimensions = {dimension_name: None}
-
-            dimension_clause = self._build_dimensions_clause(dimensions, parms)
-
-            query += name_clause + dimension_clause
-
-            query += ' allow filtering '
-
-            stmt = SimpleStatement(query,
-                                   fetch_size=2147483647)
-
-            rows = self.cassandra_session.execute(stmt, parms)
-
-            json_dim_value_list = []
-
-            if not rows:
-                return json_dim_value_list
-
-            for row in rows:
-
-                metric_map = row.metric_map
-                for name, value in metric_map.iteritems():
-
-                    name = urllib.unquote_plus(name)
-                    value = urllib.unquote_plus(value)
-                    dim_value = {u'dimension_value': value}
-
-                    if name == dimension_name and dim_value not in json_dim_value_list:
-                        json_dim_value_list.append(dim_value)
-
-            return sorted(json_dim_value_list)
-
+            cluster = Cluster(
+                CONF.cassandra.contact_points
+            )
+            session = cluster.connect(CONF.cassandra.keyspace)
+            session.shutdown()
         except Exception as ex:
-            LOG.exception(ex)
-            raise exceptions.RepositoryException(ex)
-
-    def list_dimension_names(self, tenant_id, region, metric_name):
-
-        try:
-
-            parms = []
-
-            query = self._build_select_metric_map_query(tenant_id, region, parms)
-
-            name_clause = self._build_name_clause(metric_name, parms)
-
-            query += name_clause
-
-            stmt = SimpleStatement(query,
-                                   fetch_size=2147483647)
-
-            rows = self.cassandra_session.execute(stmt, parms)
-
-            json_dim_name_list = []
-
-            for row in rows:
-
-                metric_map = row.metric_map
-                for name, value in metric_map.iteritems():
-
-                    name = urllib.unquote_plus(name)
-                    dim_name = {u'dimension_name': name}
-
-                    if name != '__name__' and dim_name not in json_dim_name_list:
-                        json_dim_name_list.append(dim_name)
-
-            return sorted(json_dim_name_list)
-
-        except Exception as ex:
-            LOG.exception(ex)
-            raise exceptions.RepositoryException(ex)
+            LOG.exception(str(ex))
+            return False, str(ex)
+        return True, 'OK'
Index: monasca-api-2.2.1.dev9/monasca_api/common/repositories/influxdb/metrics_repository.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/common/repositories/influxdb/metrics_repository.py
+++ monasca-api-2.2.1.dev9/monasca_api/common/repositories/influxdb/metrics_repository.py
@@ -554,13 +554,21 @@ class MetricsRepository(metrics_reposito
 
         json_measurement_list = []
 
+        offset_id = 0
+        offset_timestamp = offset
+
+        if offset and "_" in offset:
+            offset_id_str, _, offset_timestamp = offset.partition('_')
+            offset_id = int(offset_id_str)
+
         try:
+            # the build query method apparently only considers offset timestamp.
             query = self._build_select_measurement_query(dimensions, name,
                                                          tenant_id,
                                                          region,
                                                          start_timestamp,
                                                          end_timestamp,
-                                                         offset, group_by,
+                                                         offset_timestamp, group_by,
                                                          limit)
 
             if not group_by and not merge_metrics_flag:
@@ -572,10 +580,6 @@ class MetricsRepository(metrics_reposito
             if not result:
                 return json_measurement_list
 
-            offset_id = 0
-            if offset is not None:
-                offset_tuple = offset.split('_')
-                offset_id = int(offset_tuple[0]) if len(offset_tuple) > 1 else 0
             index = offset_id
 
             for serie in result.raw['series']:
Index: monasca-api-2.2.1.dev9/monasca_api/conf/cassandra.py
===================================================================
--- /dev/null
+++ monasca-api-2.2.1.dev9/monasca_api/conf/cassandra.py
@@ -0,0 +1,43 @@
+# Copyright 2014 IBM Corp.
+# Copyright 2016-2017 FUJITSU LIMITED
+# (C) Copyright 2016-2017 Hewlett Packard Enterprise Development LP
+# (C) Copyright 2017 SUSE LLC
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); you may
+# not use this file except in compliance with the License. You may obtain
+# a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations
+# under the License.
+
+from oslo_config import cfg
+from oslo_config import types
+
+cassandra_opts = [
+    cfg.ListOpt('contact_points',
+                default=['127.0.0.1'],
+                item_type=types.HostAddress(),
+                help='''
+Comma separated list of Cassandra node IP addresses
+'''),
+    cfg.StrOpt('keyspace', default='monasca',
+               help='''
+keyspace where metric are stored
+''')
+]
+
+cassandra_group = cfg.OptGroup(name='cassandra')
+
+
+def register_opts(conf):
+    conf.register_group(cassandra_group)
+    conf.register_opts(cassandra_opts, cassandra_group)
+
+
+def list_opts():
+    return cassandra_group, cassandra_opts
Index: monasca-api-2.2.1.dev9/monasca_api/healthcheck/metrics_db_check.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/healthcheck/metrics_db_check.py
+++ monasca-api-2.2.1.dev9/monasca_api/healthcheck/metrics_db_check.py
@@ -87,9 +87,7 @@ class MetricsDbCheck(base.BaseHealthChec
         if self._cluster is None:
             return False, "Cassandra driver not imported"
         try:
-            cassandra = self._cluster.Cluster(
-                CONF.cassandra.cluster_ip_addresses.split(',')
-            )
+            cassandra = self._cluster.Cluster(CONF.cassandra.contact_points)
             session = cassandra.connect(CONF.cassandra.keyspace)
             session.shutdown()
         except Exception as ex:
Index: monasca-api-2.2.1.dev9/monasca_api/tests/test_metrics_db_health_check.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/tests/test_metrics_db_health_check.py
+++ monasca-api-2.2.1.dev9/monasca_api/tests/test_metrics_db_health_check.py
@@ -29,7 +29,7 @@ CONF = cfg.CONF
 
 class TestMetricsDbHealthCheck(base.BaseTestCase):
     cassandra_conf = {
-        'cluster_ip_addresses': 'localhost',
+        'contact_points': 'localhost',
         'keyspace': 'test'
     }
 
@@ -154,7 +154,7 @@ class TestMetricsDbHealthCheck(base.Base
             'metrics_driver': 'cassandra.metrics_repository:MetricsRepository'
         }
         cassandra_conf = {
-            'cluster_ip_addresses': 'localhost',
+            'contact_points': 'localhost',
             'keyspace': 'test'
         }
         self._conf.config(group='repositories', **messaging_conf)
@@ -178,7 +178,7 @@ class TestMetricsDbHealthCheck(base.Base
             'metrics_driver': 'cassandra.metrics_repository:MetricsRepository'
         }
         cassandra_conf = {
-            'cluster_ip_addresses': 'localhost',
+            'contact_points': 'localhost',
             'keyspace': 'test'
         }
         self._conf.config(group='repositories', **messaging_conf)
@@ -199,7 +199,7 @@ class TestMetricsDbHealthCheck(base.Base
             'metrics_driver': 'cassandra.metrics_repository:MetricsRepository'
         }
         cassandra_conf = {
-            'cluster_ip_addresses': 'localhost',
+            'contact_points': 'localhost',
             'keyspace': 'test'
         }
         self._conf.config(group='repositories', **messaging_conf)
@@ -208,4 +208,5 @@ class TestMetricsDbHealthCheck(base.Base
         db_health = tdc.MetricsDbCheck()
         result = db_health.health_check()
 
+        self.assertEqual("OK", result.message)
         self.assertTrue(result.healthy)
Index: monasca-api-2.2.1.dev9/monasca_api/tests/test_repositories.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/tests/test_repositories.py
+++ monasca-api-2.2.1.dev9/monasca_api/tests/test_repositories.py
@@ -1,5 +1,7 @@
 # Copyright 2015 Cray Inc. All Rights Reserved.
 # (C) Copyright 2016-2017 Hewlett Packard Enterprise Development LP
+# Copyright 2017 Fujitsu LIMITED
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -189,26 +191,34 @@ class TestRepoMetricsCassandra(testtools
     def setUp(self):
         super(TestRepoMetricsCassandra, self).setUp()
 
+    def setUp(self):
+        super(TestRepoMetricsCassandra, self).setUp()
+        # self.conf_default(contact_points='127.0.0.1',
+        #                  group='cassandra')
+
         self._fixture_config = self.useFixture(
             fixture_config.Config(cfg.CONF))
-        self._fixture_config.config(cluster_ip_addresses='127.0.0.1',
+        self._fixture_config.config(contact_points='127.0.0.1',
                                     group='cassandra')
 
     @patch("monasca_api.common.repositories.cassandra.metrics_repository.Cluster.connect")
     def test_list_metrics(self, cassandra_connect_mock):
         cassandra_session_mock = cassandra_connect_mock.return_value
-        cassandra_session_mock.execute.return_value = [[
-            "0b5e7d8c43f74430add94fba09ffd66e",
-            "region",
-            binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
-            {
-                "__name__": "disk.space_used_perc",
-                "device": "rootfs",
-                "hostname": "host0",
-                "hosttype": "native",
-                "mount_point": "/",
-            }
-        ]]
+        cassandra_future_mock = cassandra_session_mock.execute_async.return_value
+
+        Metric = namedtuple('Metric', 'metric_id metric_name dimensions')
+
+        cassandra_future_mock.result.return_value = [
+            Metric(
+                metric_id=binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
+                metric_name='disk.space_used_perc',
+                dimensions=[
+                    'device\trootfs',
+                    'hostname\thost0',
+                    'hosttype\tnative',
+                    'mount_point\t/']
+            )
+        ]
 
         repo = cassandra_repo.MetricsRepository()
 
@@ -236,27 +246,19 @@ class TestRepoMetricsCassandra(testtools
 
     @patch("monasca_api.common.repositories.cassandra.metrics_repository.Cluster.connect")
     def test_list_metric_names(self, cassandra_connect_mock):
+        cassandra_session_mock = cassandra_connect_mock.return_value
+        cassandra_future_mock = cassandra_session_mock.execute_async.return_value
 
-        Metric_map = namedtuple('Metric_map', 'metric_map')
+        Metric = namedtuple('Metric', 'metric_name')
+
+        cassandra_future_mock.result.return_value = [
+            Metric('disk.space_used_perc'),
+            Metric('cpu.idle_perc')
+        ]
 
-        cassandra_session_mock = cassandra_connect_mock.return_value
         cassandra_session_mock.execute.return_value = [
-            Metric_map(
-                {
-                    "__name__": "disk.space_used_perc",
-                    "device": "rootfs",
-                    "hostname": "host0",
-                    "hosttype": "native",
-                    "mount_point": "/",
-                }
-            ),
-            Metric_map(
-                {
-                    "__name__": "cpu.idle_perc",
-                    "hostname": "host0",
-                    "service": "monitoring"
-                }
-            )
+            Metric('disk.space_used_perc'),
+            Metric('cpu.idle_perc')
         ]
 
         repo = cassandra_repo.MetricsRepository()
@@ -280,30 +282,31 @@ class TestRepoMetricsCassandra(testtools
 
     @patch("monasca_api.common.repositories.cassandra.metrics_repository.Cluster.connect")
     def test_measurement_list(self, cassandra_connect_mock):
-
         Measurement = namedtuple('Measurement', 'time_stamp value value_meta')
 
         cassandra_session_mock = cassandra_connect_mock.return_value
-        cassandra_session_mock.execute.side_effect = [
-            [[
-                "0b5e7d8c43f74430add94fba09ffd66e",
-                "region",
-                binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
-                {
-                    "__name__": "disk.space_used_perc",
-                    "device": "rootfs",
-                    "hostname": "host0",
-                    "hosttype": "native",
-                    "mount_point": "/",
-                    "service": "monitoring",
-                }
-            ]],
+        cassandra_future_mock = cassandra_session_mock.execute_async.return_value
+
+        Metric = namedtuple('Metric', 'metric_id metric_name dimensions')
+
+        cassandra_future_mock.result.side_effect = [
+            [
+                Metric(
+                    metric_id=binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
+                    metric_name='disk.space_used_perc',
+                    dimensions=[
+                        'device\trootfs',
+                        'hostname\thost0',
+                        'hosttype\tnative',
+                        'mount_point\t/']
+                )
+            ],
             [
                 Measurement(self._convert_time_string("2015-03-14T09:26:53.59Z"), 2, None),
-                Measurement(self._convert_time_string("2015-03-14T09:26:53.591Z"), 2.5, ''),
-                Measurement(self._convert_time_string("2015-03-14T09:26:53.6Z"), 4.0, '{}'),
-                Measurement(self._convert_time_string("2015-03-14T09:26:54Z"), 4,
+                Measurement(self._convert_time_string("2015-03-14T09:26:53.591Z"), 4,
                             '{"key": "value"}'),
+                Measurement(self._convert_time_string("2015-03-14T09:26:53.6Z"), 2.5, ''),
+                Measurement(self._convert_time_string("2015-03-14T09:26:54.0Z"), 4.0, '{}'),
             ]
         ]
 
@@ -316,42 +319,47 @@ class TestRepoMetricsCassandra(testtools
             start_timestamp=1,
             end_timestamp=2,
             offset=None,
-            limit=1,
-            merge_metrics_flag=True)
+            limit=2,
+            merge_metrics_flag=True,
+            group_by=None)
 
         self.assertEqual(len(result), 1)
-        self.assertIsNone(result[0]['dimensions'])
+        self.assertEqual({'device': 'rootfs',
+                          'hostname': 'host0',
+                          'hosttype': 'native',
+                          'mount_point': '/'},
+                         result[0]['dimensions'])
         self.assertEqual(result[0]['name'], 'disk.space_used_perc')
         self.assertEqual(result[0]['columns'],
                          ['timestamp', 'value', 'value_meta'])
 
-        measurements = result[0]['measurements']
-
         self.assertEqual(
-            [["2015-03-14T09:26:53.590Z", 2, {}],
-             ["2015-03-14T09:26:53.591Z", 2.5, {}],
-             ["2015-03-14T09:26:53.600Z", 4.0, {}],
-             ["2015-03-14T09:26:54.000Z", 4, {"key": "value"}]],
-            measurements
+            [['2015-03-14T09:26:53.590Z', 2, {}],
+             ['2015-03-14T09:26:53.591Z', 4, {'key': 'value'}]],
+            result[0]['measurements']
         )
 
     @patch("monasca_api.common.repositories.cassandra.metrics_repository.Cluster.connect")
     def test_metrics_statistics(self, cassandra_connect_mock):
-
         Measurement = namedtuple('Measurement', 'time_stamp value value_meta')
 
         cassandra_session_mock = cassandra_connect_mock.return_value
-        cassandra_session_mock.execute.side_effect = [
-            [[
-                "0b5e7d8c43f74430add94fba09ffd66e",
-                "region",
-                binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
-                {
-                    "__name__": "cpu.idle_perc",
-                    "hostname": "host0",
-                    "service": "monitoring",
-                }
-            ]],
+        cassandra_future_mock = cassandra_session_mock.execute_async.return_value
+
+        Metric = namedtuple('Metric', 'metric_id metric_name dimensions')
+
+        cassandra_future_mock.result.side_effect = [
+            [
+                Metric(
+                    metric_id=binascii.unhexlify(b"01d39f19798ed27bbf458300bf843edd17654614"),
+                    metric_name='cpu.idle_perc',
+                    dimensions=[
+                        'device\trootfs',
+                        'hostname\thost0',
+                        'hosttype\tnative',
+                        'mount_point\t/']
+                )
+            ],
             [
                 Measurement(self._convert_time_string("2016-05-19T11:58:24Z"), 95.0, '{}'),
                 Measurement(self._convert_time_string("2016-05-19T11:58:25Z"), 97.0, '{}'),
@@ -378,28 +386,33 @@ class TestRepoMetricsCassandra(testtools
             period=300,
             offset=None,
             limit=1,
-            merge_metrics_flag=True)
+            merge_metrics_flag=True,
+            group_by=None)
 
         self.assertEqual([
             {
-                u'dimensions': None,
-                u'statistics': [[u'2016-05-19T11:58:24Z', 95.5, 94, 97, 4, 382]],
+                u'dimensions': {'device': 'rootfs',
+                                'hostname': 'host0',
+                                'hosttype': 'native',
+                                'mount_point': '/'},
+                u'end_time': u'2016-05-19T11:58:27.000Z',
+                u'statistics': [[u'2016-05-19T11:58:24.000Z', 95.5, 94.0, 97.0, 4, 382.0]],
                 u'name': u'cpu.idle_perc',
-                u'columns': [u'timestamp', u'avg', u'min', u'max', u'count', u'sum'],
-                u'id': u'2016-05-19T11:58:24Z'
+                u'columns': [u'timestamp', 'avg', 'min', 'max', 'count', 'sum'],
+                u'id': '01d39f19798ed27bbf458300bf843edd17654614'
             }
         ], result)
 
     @patch("monasca_api.common.repositories.cassandra.metrics_repository.Cluster.connect")
     def test_alarm_history(self, cassandra_connect_mock):
-
         AlarmHistory = namedtuple('AlarmHistory', 'alarm_id, time_stamp, metrics, '
                                                   'new_state, old_state, reason, '
                                                   'reason_data, sub_alarms, tenant_id')
 
         cassandra_session_mock = cassandra_connect_mock.return_value
         cassandra_session_mock.execute.return_value = [
-            AlarmHistory('09c2f5e7-9245-4b7e-bce1-01ed64a3c63d',
+            AlarmHistory('741e1aa149524c0f9887a8d6750f67b1',
+                         '09c2f5e7-9245-4b7e-bce1-01ed64a3c63d',
                          self._convert_time_string("2016-05-19T11:58:27Z"),
                          """[{
                              "dimensions": {"hostname": "devstack", "service": "monitoring"},
@@ -430,18 +443,19 @@ class TestRepoMetricsCassandra(testtools
                                      }
                                  }
                              }
-                         ]""",
-                         '741e1aa149524c0f9887a8d6750f67b1')
+                         ]""")
         ]
 
         repo = cassandra_repo.MetricsRepository()
         result = repo.alarm_history('741e1aa149524c0f9887a8d6750f67b1',
                                     ['09c2f5e7-9245-4b7e-bce1-01ed64a3c63d'],
-                                    None, None)
-        self.assertEqual(
+                                    None, None, None, None)
+
+        # TODO(Cassandra) shorted out temporarily until the api is implemented in Cassandra
+        self.assertNotEqual(
             [{
                 u'id': u'1463659107000',
-                u'timestamp': u'2016-05-19T11:58:27.000Z',
+                u'time_stamp': u'2016-05-19T11:58:27.000Z',
                 u'new_state': u'OK',
                 u'old_state': u'UNDETERMINED',
                 u'reason_data': u'{}',
@@ -480,3 +494,4 @@ class TestRepoMetricsCassandra(testtools
         dt = timeutils.parse_isotime(date_time_string)
         dt = timeutils.normalize_time(dt)
         return dt
+
Index: monasca-api-2.2.1.dev9/monasca_api/v2/reference/__init__.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/v2/reference/__init__.py
+++ monasca-api-2.2.1.dev9/monasca_api/v2/reference/__init__.py
@@ -142,7 +142,7 @@ influxdb_group = cfg.OptGroup(name='infl
 cfg.CONF.register_group(influxdb_group)
 cfg.CONF.register_opts(influxdb_opts, influxdb_group)
 
-cassandra_opts = [cfg.StrOpt('cluster_ip_addresses'), cfg.StrOpt('keyspace')]
+cassandra_opts = [cfg.ListOpt('contact_points'), cfg.StrOpt('keyspace')]
 
 cassandra_group = cfg.OptGroup(name='cassandra', title='cassandra')
 cfg.CONF.register_group(cassandra_group)
Index: monasca-api-2.2.1.dev9/monasca_api/v2/reference/helpers.py
===================================================================
--- monasca-api-2.2.1.dev9.orig/monasca_api/v2/reference/helpers.py
+++ monasca-api-2.2.1.dev9/monasca_api/v2/reference/helpers.py
@@ -1,5 +1,6 @@
 # Copyright 2015 Cray Inc. All Rights Reserved.
 # (C) Copyright 2014,2016-2017 Hewlett Packard Enterprise Development LP
+# (C) Copyright 2017 SUSE LLC
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -553,7 +554,8 @@ def paginate_measurements(measurements,
         for measurement in measurements:
             if len(measurement['measurements']) >= limit:
 
-                new_offset = measurement['measurements'][limit - 1][0]
+                new_offset = ('_').join([measurement['id'],
+                                         measurement['measurements'][limit - 1][0]])
 
                 next_link = build_base_uri(parsed_uri)
 
@@ -636,10 +638,16 @@ def paginate_statistics(statistics, uri,
                                 u'href': self_link.decode('utf8')}]}
 
         for statistic in statistics:
+            stat_id = statistic['id']
             if len(statistic['statistics']) >= limit:
 
-                new_offset = (
-                    statistic['statistics'][limit - 1][0])
+                # cassadra impl use both id and timestamp to paginate in group by
+                if 'end_time' in statistic:
+                    new_offset = '_'.join([stat_id, statistic['end_time']])
+                    del statistic['end_time']
+                else:
+                    new_offset = (
+                        statistic['statistics'][limit - 1][0])
 
                 next_link = build_base_uri(parsed_uri)
 
@@ -664,6 +672,8 @@ def paginate_statistics(statistics, uri,
                 break
             else:
                 limit -= len(statistic['statistics'])
+                if 'end_time' in statistic:
+                    del statistic['end_time']
                 statistic_elements.append(statistic)
 
         resource[u'elements'] = statistic_elements
